package worldcontrolteam.worldcontrol.client.gui.features;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.tileentity.TileEntityInfoPanel;

public class GuiInfoPanelShowLabels extends GuiButton {
  private static final String TEXTURE_FILE = "worldcontrol:textures/gui/gui_info_panel.png";
  private static final ResourceLocation TEXTURE_LOCATION = new ResourceLocation(TEXTURE_FILE);

  private boolean checked;

  public GuiInfoPanelShowLabels(int id, int x, int y, TileEntityInfoPanel panel) {
    super(id, x, y, 0, 0, "");
    field_146121_g = 9;
    field_146120_f = 18;
    checked = panel.shouldShowLabels();
  }

  @Override
  public void func_191745_a(Minecraft mc, int mouseX, int mouseY, float partialTicks) {
    if(this.field_146125_m){
      Minecraft.func_71410_x().field_71446_o.func_110577_a(TEXTURE_LOCATION);
      GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
      int delta = checked ? 12 : 21;
      func_73729_b(this.field_146128_h, this.field_146129_i + 1, 176, delta, 18, 9);
    }
  }

  @Override
  public int func_146114_a(boolean flag) {
    return 0;
  }

  @Override
  public boolean func_146116_c(Minecraft minecraft, int i, int j) {
    if (super.func_146116_c(minecraft, i, j)) {
      checked = !checked;
      return true;
    } else {
      return false;
    }
  }

}
