package worldcontrolteam.worldcontrol.client.render;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.api.screen.IScreenElement;
import worldcontrolteam.worldcontrol.tileentity.TileEntityInfoPanel;

/**
 * File created by mincrmatt12 on 6/18/2018.
 * Originally written for WorldControl.
 * <p>
 * See LICENSE.txt for license information.
 */
public class RenderInfoPanel extends TileEntitySpecialRenderer<TileEntityInfoPanel> {
    @Override
    public void func_192841_a(TileEntityInfoPanel te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        if (te.ise == null) return;
        if (!te.getPowered()) return;
        IScreenElement ise = te.ise;

        GlStateManager.func_179094_E();
        x = x - (te.func_174877_v().func_177958_n() - te.origin.func_177958_n()) - 0.0001;
        y = y - (te.func_174877_v().func_177956_o() - te.origin.func_177956_o()) - 0.0001;
        z = z - (te.func_174877_v().func_177952_p() - te.origin.func_177952_p()) - 0.0001;

        double sizeX = te.end.func_177958_n() - te.origin.func_177958_n() + .75;
        double sizeY = te.end.func_177956_o() - te.origin.func_177956_o() + .75;
        double sizeZ = te.end.func_177952_p() - te.origin.func_177952_p() + .75;

        switch (te.facing) {
            case NORTH:
                GlStateManager.func_179137_b(x+.2, y+.1, z);
                GlStateManager.func_179139_a(sizeX / ((float)sizeX * 64), sizeY / ((float)sizeY * 64), 1);
                GlStateManager.func_179137_b(sizeX * 64, sizeY * 64, 0);
                GlStateManager.func_179152_a(-1, -1, 1);
                //GlStateManager.translate(0.125, -0.125, 0);
                //GlStateManager.scale(-1, 1, 1);
                ise.draw((int)(sizeX * 64), (int)(sizeY * 64));
                break;
            case SOUTH:
                //GlStateManager.translate(0.125, -0.125, 0);
                GlStateManager.func_179137_b(x+sizeX+.05, y+.18, z+1.001);
                GlStateManager.func_179114_b(180, 0, 1, 0);
                GlStateManager.func_179139_a(sizeX / ((float)sizeX * 64), sizeY / ((float)sizeY * 64), 1);
                GlStateManager.func_179137_b(sizeX * 64, sizeY * 64, 0);
                GlStateManager.func_179152_a(-1, -1, 1);
                //GlStateManager.translate(0.125, 0.125, 0);
                //GlStateManager.scale(-1, 1, 1);
                ise.draw((int)(sizeX * 64), (int)(sizeY * 64));
                break;
            case EAST:
                GlStateManager.func_179137_b(x+1.001, y+.18, z+.2);
                GlStateManager.func_179114_b(-90, 0, 1, 0);
                GlStateManager.func_179139_a(sizeZ / ((float)sizeZ * 64), sizeY / ((float)sizeY * 64), 1);
                GlStateManager.func_179137_b(sizeZ * 64, sizeY * 64, 0);
                GlStateManager.func_179152_a(-1, -1, 1);
                GlStateManager.func_179137_b(0.125, 0.125, 0);

                ise.draw((int)(sizeZ * 64), (int)(sizeY * 64));
                break;
            case WEST:
                GlStateManager.func_179137_b(x, y+.18, z+sizeZ+.05);
                GlStateManager.func_179114_b(90, 0, 1, 0);
                GlStateManager.func_179139_a(sizeZ / ((float)sizeZ * 64), sizeY / ((float)sizeY * 64), 1);
                GlStateManager.func_179137_b(sizeZ * 64, sizeY * 64, 0);
                GlStateManager.func_179152_a(-1, -1, 1);
                GlStateManager.func_179137_b(0.125, 0.125, 0);

                ise.draw((int)(sizeZ * 64), (int)(sizeY * 64));
            default:
                break;
        }
        GlStateManager.func_179121_F();
    }
}
