package worldcontrolteam.worldcontrol.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import worldcontrolteam.worldcontrol.inventory.SlotFilterItemHandler;
import worldcontrolteam.worldcontrol.tileentity.TileEntityInfoPanel;

public class ContainerInfoPanel extends Container
{
  public TileEntityInfoPanel panel;


  public ContainerInfoPanel()
  {
    super();
  }


  public ContainerInfoPanel(EntityPlayer player, TileEntityInfoPanel panel)
  {
    super();

    this.panel = panel;

    //card
    func_75146_a(new SlotFilterItemHandler(panel, 0, 8, 24+18));

    //range upgrade
    func_75146_a(new SlotFilterItemHandler(panel, 1, 8, 24+18*2));

    //color upgrade
    func_75146_a(new SlotFilterItemHandler(panel, 2, 8, 24+18*3));

    //inventory
    for (int i = 0; i < 3; i++) {
      for (int k = 0; k < 9; k++) {
        func_75146_a(new Slot(player.field_71071_by, k + i * 9 + 9, 8 + k * 18, 24 + 84 + i * 18));
      }
    }

    for (int j = 0; j < 9; j++) {
      func_75146_a(new Slot(player.field_71071_by, j, 8 + j * 18, 24 + 142));
    }
  }

  @Override
  public boolean func_75145_c(EntityPlayer var1)
  {
    return true;
  }

  public void func_75134_a(EntityPlayer playerIn)
  {
    super.func_75134_a(playerIn);
    this.panel.closeInventory(playerIn);
  }


  @Override
  public ItemStack func_82846_b(EntityPlayer p, int slotId)
  {
    Slot slot = (Slot)this.field_75151_b.get(slotId);
    if (slot != null) {
      ItemStack items = slot.func_75211_c();
      if (items != ItemStack.field_190927_a) {
        int initialCount = items.func_190916_E();
        if (slotId < panel.getSlots()) {
          //moving from panel to inventory
          if(!func_75135_a(items, panel.getSlots(), field_75151_b.size(), false)){
            return ItemStack.field_190927_a;
          }
          if (items.func_190916_E() == 0) {
            slot.func_75215_d(ItemStack.field_190927_a);
          } else {
            slot.func_75218_e();
            if(initialCount != items.func_190916_E())
              return items;
          }
        } else {
          //moving from inventory to panel
          for (int i = 0;i < panel.getSlots();i++) {
            if (!panel.isItemValid(i, items)) {
              continue;
            }
            ItemStack targetStack = panel.getStackInSlot(i);
            if (targetStack == ItemStack.field_190927_a) {
              Slot targetSlot = (Slot)this.field_75151_b.get(i);
              targetSlot.func_75215_d(items);
              slot.func_75215_d(ItemStack.field_190927_a);
              break;
            } else if(items.func_77985_e() && items.func_77969_a(targetStack)) {
              func_75135_a(items, i, i+1, false);
              if (items.func_190916_E() == 0) {
                slot.func_75215_d(ItemStack.field_190927_a);
              } else {
                slot.func_75218_e();
                if (initialCount != items.func_190916_E())
                  return items;
              }
              break;
            }
          }
        }
      }
    }
    return ItemStack.field_190927_a;
  }

}
