package worldcontrolteam.worldcontrol.inventory.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import worldcontrolteam.worldcontrol.api.card.ICard;
import worldcontrolteam.worldcontrol.api.card.predefs.IProviderCard;
import worldcontrolteam.worldcontrol.init.WCContent;
import worldcontrolteam.worldcontrol.inventory.InventoryItem;
import worldcontrolteam.worldcontrol.inventory.SlotFilter;

public class ContainerRemotePanel extends Container {

    protected ItemStack is;
    protected InventoryItem item;

    public ContainerRemotePanel(InventoryPlayer inv, ItemStack stack, InventoryItem iItem) {
        this.is = stack;
        this.item = iItem;

        this.func_75146_a(new SlotFilter(this.item, 0, 177, 21));
        bindPlayerInventory(inv);
    }

    protected void bindPlayerInventory(InventoryPlayer inventoryPlayer) {
        /*
         * for (int i = 0; i < 3; i++) { for (int j = 0; j < 9; j++) {
         * addSlotToContainer(new Slot(inventoryPlayer, j + i * 9 + 9, 8 + j *
         * 18, 84 + i * 18)); } }
         */

        for (int i = 0; i < 9; i++)
            func_75146_a(new Slot(inventoryPlayer, i, 8 + i * 18, 142));
    }

    @Override
    public boolean func_75145_c(EntityPlayer p_75145_1_) {
        return true;
    }

    @Override
    public ItemStack func_82846_b(EntityPlayer player, int slot) {
        ItemStack stack = null;
        Slot slots = this.field_75151_b.get(slot);

        if (slots.func_75211_c() != ItemStack.field_190927_a)
            if (slots.func_75211_c().func_77973_b() == WCContent.REMOTE_PANEL)
                return null;

        if (slots != null && slots.func_75216_d()) {
            ItemStack itemstackR = slots.func_75211_c();
            stack = itemstackR.func_77946_l();

            if (slot == 0) {
                boolean fixed = false;
                for (int h = 1; h < 10; h++) {
                    Slot know = this.field_75151_b.get(h);
                    if (!know.func_75216_d()) {
                        know.func_75215_d(slots.func_75211_c());
                        slots.func_75209_a(1);
                        fixed = true;
                    }
                }
                if (!fixed)
                    return null;
                slots.func_75220_a(itemstackR, stack);
            } else if (slots.func_75211_c().func_77973_b() instanceof ICard && !this.field_75151_b.get(0).func_75216_d()) {
                this.field_75151_b.get(0).func_75215_d(itemstackR);
                slots.func_75209_a(1);
                slots.func_75220_a(itemstackR, stack);
                this.field_75151_b.get(0).func_75218_e();
            } else return null;
        }
        return stack;
    }

    @Override
    public ItemStack func_184996_a(int slot, int dragType, ClickType click, EntityPlayer player) {
        if (slot >= 0 && func_75139_a(slot) != null && func_75139_a(slot).func_75211_c() == player.func_184614_ca())
            return null;
        return super.func_184996_a(slot, dragType, click, player);
    }
}
