package worldcontrolteam.worldcontrol.client.gui.features;


import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.network.ChannelHandler;
import worldcontrolteam.worldcontrol.network.messages.PacketClientUpdateMonitor;
import worldcontrolteam.worldcontrol.tileentity.TileEntityBaseReactorHeatMonitor;

@SideOnly(Side.CLIENT)
public class GuiThermoInvertRedstone extends GuiButton {

    private static final String TEXTURE_FILE = "worldcontrol:textures/gui/guithermalmonitor.png";
    private static final ResourceLocation TEXTURE_LOCATION = new ResourceLocation(TEXTURE_FILE);

    TileEntityBaseReactorHeatMonitor thermo;
    private boolean checked;

    public GuiThermoInvertRedstone(int id, int x, int y, TileEntityBaseReactorHeatMonitor thermo) {
        super(id, x, y, 0, 0, "");
        field_146121_g = 15;
        field_146120_f = 51;
        this.thermo = thermo;
        checked = thermo.getInversion();
    }

    @Override
    public void func_191745_a(Minecraft minecraft, int par2, int par3, float iDoThings) {
        if (this.field_146125_m) {
            minecraft.field_71446_o.func_110577_a(TEXTURE_LOCATION);
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            int delta = checked ? 15 : 0;
            func_73729_b(field_146128_h, field_146129_i + 1, 199, delta, 51, 15);
        }
    }

    @Override
    public int func_146114_a(boolean flag) {
        return 0;
    }

    @Override
    public boolean func_146116_c(Minecraft minecraft, int i, int j) {
        if (super.func_146116_c(minecraft, i, j)) {
            checked = !checked;
            thermo.setInverse(checked);
            ChannelHandler.network.sendToServer(new PacketClientUpdateMonitor(thermo.getThreshhold(), checked, thermo.func_174877_v()));
            return true;
        } else
            return false;
    }
}
